<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { ref, inject } from 'vue';
import { useRouter } from 'vue-router';
import Modal from '@/components/general/Modal.vue';
import MailChooser from '@/components/general/form/MailChooser.vue';
import Input from '@/components/general/form/Input.vue';
import { usePreviewStore } from '@/stores/preview';
import { useAccountStore } from '@/stores/account';
import { getCookie } from '@/lib/utils';
import { request } from '@/lib/request';
import Button from '@/components/general/Button.vue';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const $t = t;
const router = useRouter();
const accountStore = useAccountStore();
const store = usePreviewStore();
const { mailValid, previewHashcode, paneType, headline } = storeToRefs(store);
const { mail, accesscode } = storeToRefs(accountStore);
let configuration = inject<any>('configuration');

const emits = defineEmits<{
    (e: 'close' ):void
}>();

const cancel = ()=>{
    emits('close');
}

const submit = async ()=>{
    let params = {
        accesscode: accesscode.value, 
        mail: mail.value.split('@')[0],
        id: previewHashcode.value,
        domain: '@' + mail.value.split('@')[1],
        headline: name.value
    };             
    let response = await request('POST', configuration.apiServer+`/api/${paneType.value}/copy/different/`, {
        params: params
    });
    if(response && response.success && response.redirectID){
        router.push({name:'copy-pane', params:{id: response.redirectID}});
        //showConfirmModal(true);
    }
    else if(response && response.success && response.message === "account-existing"){
        showConfirmModal(true);
    }
    else if(response && response.reason!=null && response.reason==="Not Allowed"){
        isNotAllowed.value = true;
        showErrorModal(true);
    }
    else{
        showErrorModal(true);
    }

    accesscode.value = '';
    mailValid.value = true;
};

const isConfirmModalOpen = ref(false);

const closeConfirmModal = ()=>{
    showConfirmModal(false);
    router.push({name:'overview-account'});
}
const showConfirmModal = (value:boolean)=>{
    isConfirmModalOpen.value = value;
}

const isNotAllowed = ref(false);
const isErrorModalOpen = ref(false);
const showErrorModal = (value:boolean)=>{
    isErrorModalOpen.value = value;
    if(!value)
        cancel();
}

const login = ()=>{
    router.push({name: 'login'});
}

const name = ref($t('general.variables.copy') + headline.value);

</script>
<template>
<Modal :labelCancel="$t('general.buttons.cancel')" :labelSubmit="accesscode.length > 0 && mail ?$t('adminMenu.copy.label'):undefined" :header="$t('adminMenu.copy.forMe.title')" @cancel="cancel" @submit="submit">
    <div class="mt-0.5" v-if="getCookie('Token')">
        <Input type="text" :placeholder="$t('placeholder.accesscode')" v-model="accesscode" :readonly="true" />
        <MailChooser :key="mail" :saved-mail="mail" :read-only="true" v-if="mail" />
        <Input type="text" :placeholder="$t('contentPage.post.headline')" v-model="name" />
    </div>
    <div v-else>
        <Button @click="login" variant="confirm">{{ $t('indexPage.buttonTexts.login.header') }}</Button>
    </div>
    <Modal v-if="isConfirmModalOpen" @submit="closeConfirmModal" :header="$t('adminMenu.copy.confirmation')" :text="$t('adminMenu.copy.forMe.claimed.submit')" :labelSubmit="$t('general.buttons.ok')" />
    <Modal v-if="isErrorModalOpen" @submit="showErrorModal(false)" :header="$t('adminMenu.copy.error')" :text="isNotAllowed?$t('confirmationPage.text.error.noAccess'):$t('confirmationPage.text.error.general')" :labelSubmit="$t('general.buttons.ok')" />
</Modal>
</template>